代码改变世界

[LeetCode] 1. Two Sum_Easy tag: Hash Table

2018-08-10 12:16  Johnson_强生仔仔  阅读(259)  评论(0编辑  收藏  举报

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

 

思路为hash table, 每次将target - num 在d里面找, 如果有, 返回两个index, 否则将d[index] = num 更新d.

 

1. Constraints

1) exactly one solution, 总是有解, 所以无edge case

 

2. Ideas

hash table T: O(n) S: O(n)

 

3. Code

class Solution:
    def twoSum(self, nums, target):
        d = {}
        for index, num in enumerate(nums):
            rem = target - num
            if rem in d:
                return [d[rem], index]
            d[num] = index